// Output verification program for task TEA, author: Dawid Dabrowski

#include <cstdio>
#include <vector>
#include <cstring>

#include "oi.h"

#define REP(i,n) for(int _n=n, i=0;i<_n;++i)
#define FOR(i,a,b) for(int i=(a),_b=(b);i<=_b;++i)
#define FORD(i,a,b) for(int i=(a),_b=(b);i>=_b;--i)
#define FORE(i,x) for(__typeof((x).begin()) i=(x).begin();i != (x).end();++i)
#define X first
#define Y second
#define PB push_back	
#define MP make_pair
using namespace std;

void own_error_function(const char* msg, int line, int position) {
	printf("WRONG\n%s\n",msg);
	exit(1);
}

/* argv[1] - input
 * argv[2] - contestant's output
 * argv[3] - model solution's output
 */

const int MAXN = 1000000;

int n;
int R,S;
int a[MAXN];

bool used[MAXN];

int main(int argc, char **argv){
	oi::Scanner in(argv[1], own_error_function, oi::EN);
	oi::Scanner out(argv[2], own_error_function, oi::EN);
	oi::Scanner out_correct(argv[3], own_error_function, oi::EN);

	n=in.readInt(1,MAXN);
	R=out_correct.readInt(1,n); out_correct.skipWhitespaces();
	S=0;
	for(int i=0; i<R; ++i) {
		int cur=out_correct.readInt(1,n);
		if(cur>S) S=cur;
		while(cur--) {
			out_correct.readSpace();
			out_correct.readInt(1,n);
		}
		out_correct.readEoln();
	}
	in.readEoln();
	for(int i=0; i<n; ++i) {
		a[i]=in.readInt(1,n);
		in.readEoln();
	}
//	printf("przeczytalem out_correct\n");

	// Output validation begins here

	int userR=out.readInt(1,n);
	if(userR!=R) {
		out.error("Incorrect number of teams.\n");
		exit(1);
	}
        out.skipWhitespacesUntilEOLN();
	out.readEoln();


	int mxsize=-1;

	for(int i=0; i<R; ++i) {
		int cursize=out.readInt(1,n);
		if(cursize>mxsize) mxsize=cursize;
		for(int j=0; j<cursize; ++j) {
			out.readSpace();
			int cur=out.readInt(1,n);
			--cur;
			if(used[cur]) {
				char err[50];
				sprintf(err,"Child %d assigned to multiple teams.\n",cur+1);
				out.error(err);
			}
			used[cur]=1;
			if(a[cur]>cursize) {
				char err[50];
				sprintf(err,"Child %d assigned to a too small team.\n",cur+1);
				out.error(err);
			}
		}
                out.skipWhitespacesUntilEOLN();
                if(i < R - 1)
		    out.readEoln();
	}
        out.skipWhitespaces();
	out.readEof();
        for(int i=0; i<n; ++i) if(!used[i]) {
            char err[50];
            sprintf(err, "Child %d not assigned to any team.\n", i+1);
            out.error(err);
        }
	if(mxsize>S) {
		out.error("The biggest team is bigger than necessary.\n");
	}
	if(mxsize<S) {
		out.error("Judges output is incorrect. Inform the organizers!\n");
	}
	printf("OK\n");
	return 0;
};
